;;==========================================================================
;;   SPI 
;;  r16
;;

;
; /  r16
;
spi_IO:
 out	SPDR, r16
spi_IO_1:
 sbis	SPSR, SPIF
 rjmp	spi_IO_1
 in	r16, SPDR
 ret

;
;  SPI
;
spi_Init:
 sbi	DDRB, 5		; MOSI
 sbi	DDRB, 7		; SCK

; -SPIE - INT enable
; SPE - SPI enable
; -DORD - LSB first
; MSTR - master mode
; -CPOL - SCK is high when idle
; -CPHA -  SCK
; -SPR0, -SPR1, SPI2X - divider [8 / 2 ]

 ldi	r16, (1<<SPE) | (1<<MSTR)
; ldi	r16, (1<<SPE) | (1<<MSTR) | (1<<SPR0) | (1<<SPR1)
 out	SPCR, r16
 ldi	r16, (1<<SPI2X)
; ldi	r16, 0
 out	SPSR, r16

 ldi	r16, spi_CSCLK_release		;  ,  RES     CS = 0

;
;       
;   __   PORTB.2
;
.equ	spi_CSCLK_release	= 0xC8	;   r16,    SPI  
.equ	spi_CSCLK_LCDKB_Data	= 0xD9
.equ	spi_CSCLK_SD		= 0xC0	; spi_CSCLK_release -    (
.equ	spi_CSCLK_LCDKB_Ctrl	= 0xC9	;    LCD    Secure Digital Flash)
.equ	spi_CSCLK_VLSI_SDI	= 0x48	; vs1011   release    SCI
.equ	spi_CSCLK_VLSI_SCI	= 0x88
;
spi_CSCLK_Select:
 sbi	PORTB, 2	;   (!PORTB.2)    ̣,      IDE,
 sbrc	r16, 0		; ..  Σ    ,   
 cbi	PORTB, 2	;    IDE.       PORTC
 sbi	DDRB, 2

 out	PORTC, r16
 ldi	r16, 0xFF
 out	DDRC, r16
 ret
